// MyCustomDraw.h: interface for the CMyCustomDraw class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYCUSTOMDRAW_H__690B7811_E026_417C_8672_E0E5B4B579C6__INCLUDED_)
#define AFX_MYCUSTOMDRAW_H__690B7811_E026_417C_8672_E0E5B4B579C6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Dapfor/GUI/CustomDraw.h>

class CMyCustomDraw : public Dapfor::GUI::CCustomDraw
{
	typedef Dapfor::GUI::CCustomDraw BaseClass;
public:
	CMyCustomDraw(bool autoDelete);
	virtual ~CMyCustomDraw();


	// Called to draw a cell. 
    virtual void DrawLine(Dapfor::GUI::CGridLine& line, const Dapfor::GUI::CPaintContext& paintContext, UINT paintFilter);


	// Called to draw a cell. 
    virtual void DrawCell(Dapfor::GUI::CGridCell& cell, const Dapfor::GUI::CPaintContext& paintContext, UINT paintFilter);

    /// Calculates an optimal width of a cell taking into account a font, hierarchy, text size...
    virtual int GetOptimalCellWidth(Dapfor::GUI::CGridCell& cell, const Dapfor::GUI::CPaintContext& paintContext, UINT paintFilter) const;

    virtual int GetOptimalRowHeight(CFont* font, CDC& dc) const;

	void EnableColoring(bool enable);
	bool IsColoringEnabled() const;

	void EnableIconsPainting(bool enable);
	bool IsIconsPaintingEnabled() const;

private:
	CImageList m_Bullets;
	bool m_EnableColoring;
	bool m_EnableIconsPainting;

};

#endif // !defined(AFX_MYCUSTOMDRAW_H__690B7811_E026_417C_8672_E0E5B4B579C6__INCLUDED_)
