// Order.h: interface for the COrder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORDER_H__524ACA9A_461A_4C99_98A7_8004BA7EC211__INCLUDED_)
#define AFX_ORDER_H__524ACA9A_461A_4C99_98A7_8004BA7EC211__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <Dapfor/Common/DataObject.h>
#include "ProductManager.h"
#include "Types.h"


class COrder : public Dapfor::Common::CDataObject  
{
public:
    enum Fields
    {
		//The common fields
		FidCommonFields = FidObjectType,

		//Fields, reserved only for the COrder class
        FidProduct = FidOrderBase,
        FidUnitPrice,
        FidCount,
        FidPrice,
        FidTimeStamp,
        FidStatus,
    };

    enum Status
    {
        Ordered,
        Payed,
        Refunded,
        Cancelled,
    };

public:
    COrder(CProductManager::Product product, long count, long timeStamp, Status status);
    virtual ~COrder();

    CProductManager::Product GetProduct() const;
    double                   GetUnitPrice() const;
    long                     GetCount() const;
    double                   GetPrice() const;
    long                     GetTimeStamp() const;
    Status                   GetStatus() const;

	//Sets methods
	void SetCount(long count);
	void SetTimeStamp(long timeStamp);
	void SetStatus(COrder::Status status);
	long GetObjectType() const;

private:
    CProductManager::Product m_Product;
    long    m_Count;
    long    m_TimeStamp;
    Status  m_Status;

    DF_DECLARE_FIELD_MAP(); 
};

#endif // !defined(AFX_ORDER_H__524ACA9A_461A_4C99_98A7_8004BA7EC211__INCLUDED_)
