#pragma once

#include "Types.h"
#include <Dapfor/Common/DataObject.h>

using namespace Dapfor;

//Log message. Instances of this class are added to the bottom grid.
class CLogMessage : public Common::CDataObject
{
public:
    //List of available fields
    enum Fields
    {
        FidActionType,
        FidTimestamp,
        FidMessage,
    };


public:
    //Constructor
    CLogMessage(LogActionType actionType, const TString& message);

    //Public methods
    long        GetActionType() const;  
    __int64     GetTimestamp() const;   
    TString     GetMessage() const; 


private:
    //Private fields
    long        m_ActionType;
    __int64     m_Timestamp;
    TString     m_Message;

private:
    //Declaration of accessors to functions of this class by their identifiers (Fields enumeration)
    DF_DECLARE_FIELD_MAP();
};
